'by Steven
'assembles program

'version 002 adding support for seperatly setting and getting z, c, r and i

CONST
  maxLabels=20
  labelLength=5
  
VAR
  long destflag[16]  'whether each destination is an address or a label
  long sourceflag[16] 'as above but for source
  'long labelflag[16]  'whether each line has a label
  long valueflag[16]  'whether each is a value
  long program[512] 'for storing our program in
  word programStart
  byte labelText[(labelLength+1)*maxLabels] 'space for storing label text
  word labelAddress[maxLabels] 'the address where the label is
  byte numLabels

PUB setProgramStart(pStart)
  programStart:=pStart

PUB startProgram|temp
  repeat temp from 0 to 511
    if checkIfDestLabel(temp)
      newDest(temp,labelAddress[getDest(temp)])
    if checkIfSourceLabel(temp)
      newSource(temp,labelAddress[getSource(temp)])
  repeat temp from 0 to 16-1
    destflag[temp]:=0
    sourceflag[temp]:=0  
  return cognew(programStart,0)

PUB newLabel(linenum,label)|temp,temp1
  'check if label for that linenum already exists
  if numLabels>maxLabels
    return
  temp1:=numLabels
  repeat temp from 0 to numLabels-1
    if linenum==labelAddress[temp]
      temp1:=temp
  'make address right
  labelAddress[temp1]:=linenum
  'make string right
  repeat temp from 0 to labelLength+1
    labelText[temp1*(labelLength+1)+temp]:=byte[label][temp]
  'increment numlabels
  numLabels++
  
PUB getLabel(linenum)|temp
  repeat temp from 0 to numLabels-1
    if labelAddress[temp]==linenum
      return @labelText[(labelLength+1)*temp]
  return 0 'string can't start at 0 in hub memory, so 0 means no label
            
PUB getDest(linenum)
  return (long[programStart][linenum]>>9)&$1FF

PUB getDestLabel(linenum)
  return @labelText[(labelLength+1)*getDest(linenum)]

PUB checkIfDestLabel(linenum)
  if destflag[linenum/16]&(|<(linenum//16))==|<(linenum//16)
    return true
  return false

PUB newDest(linenum,destination)
  destination:=destination<<9
  long[programStart][linenum]:=long[programStart][linenum]&%11111111111111000000000111111111
  long[programStart][linenum]:=long[programStart][linenum]|destination
  destflag[linenum/16]:=destflag[linenum/16]&(!(|<(linenum//16)))

PUB numLabel
  return numLabels
  
PUB newDestLabel(linenum,label)|temp
  repeat temp from 0 to numLabels-1
    if strcomp(label,@labelText[(labelLength+1)*temp])
      newDest(linenum,temp)
      destflag[linenum/16]:=destflag[linenum/16]|(|<(linenum//16))
      return

PUB getSourceLabel(linenum)
  return @labelText[(labelLength+1)*getSource(linenum)]

PUB checkIfSourceLabel(linenum)
  if sourceflag[linenum/16]&(|<(linenum//16))==|<(linenum//16)
    return true
  return false

PUB newSourceLabel(linenum,label)|temp
  repeat temp from 0 to numLabels-1
    if strcomp(label,@labelText[(labelLength+1)*temp])
      newSource(linenum,temp)
      sourceflag[linenum/16]:=sourceflag[linenum/16]|(|<(linenum//16))
      return

PUB getSource(linenum)
  return long[programStart][linenum]&$1FF

PUB newSource(linenum,source)
  long[programStart][linenum]:=long[programStart][linenum]&%11111111111111111111111000000000
  long[programStart][linenum]:=long[programStart][linenum]|source
  sourceflag[linenum/16]:=sourceflag[linenum/16]&(!(|<(linenum//16)))

PUB getzcri(linenum)
  return (long[programStart][linenum]>>22)&$F

PUB newZcri(linenum,zcri)
  zcri:=zcri<<22
  long[programStart][linenum]:=long[programStart][linenum]&%11111100001111111111111111111111
  long[programStart][linenum]:=long[programStart][linenum]|zcri

PUB getZ(linenum)
  return (long[programStart][linenum]>>25)&1

PUB newZ(linenum,i)
  i:=(i&1)<<25
  long[programStart][linenum]:=long[programStart][linenum]&%11111101111111111111111111111111
  long[programStart][linenum]:=long[programStart][linenum]|i
  
PUB getC(linenum)
  return (long[programStart][linenum]>>24)&1

PUB newC(linenum,i)
  i:=(i&1)<<24
  long[programStart][linenum]:=long[programStart][linenum]&%11111110111111111111111111111111
  long[programStart][linenum]:=long[programStart][linenum]|i
  
PUB getR(linenum)
  return (long[programStart][linenum]>>23)&1

PUB newR(linenum,i)
  i:=(i&1)<<23
  long[programStart][linenum]:=long[programStart][linenum]&%11111111011111111111111111111111
  long[programStart][linenum]:=long[programStart][linenum]|i
  
PUB getI(linenum)
  return (long[programStart][linenum]>>22)&1

PUB newI(linenum,i)
  i:=i<<22
  long[programStart][linenum]:=long[programStart][linenum]&%11111111101111111111111111111111
  long[programStart][linenum]:=long[programStart][linenum]|i
  
PUB getCondition(linenum)
  return (long[programStart][linenum]>>18)&$F

PUB newCondition(linenum,cond)
  cond:=cond<<18
  long[programStart][linenum]:=long[programStart][linenum]&%11111111110000111111111111111111
  long[programStart][linenum]:=long[programStart][linenum]|cond

PUB getInst(linenum)
  return long[programStart][linenum]>>constant(32-6)

PUB newInst(linenum,inst)
  inst:=inst<<26         'shift to the rigt place
  long[programStart][linenum]:=long[programStart][linenum]&%00000011111111111111111111111111  'set instruction bits to 0
  long[programStart][linenum]:=long[programStart][linenum]|inst            'put in the instruction

PUB checkIfValue(linenum)
  if valueflag[linenum/16]&(|<(linenum//16))==|<(linenum//16)
    return true
  return false
  
PUB switchValueView(linenum)
  valueflag[linenum/16]:=valueflag[linenum/16]^(|<(linenum//16))
  
PUB getValue(linenum)
  return long[programStart][linenum]

PUB newValue(linenum,value)
  long[programStart][linenum]:=value
  valueflag[linenum/16]:=valueflag[linenum/16]|(|<(linenum//16))

  